#include <xc.h>
#include <stdio.h>
#include <stdint.h>
#include <math.h>
#include "usart.h"



#define  _XTAL_FREQ 4000000UL



/////////inicializacia jednotky usart////////////                     
void USARTinit (void)
{
 TRISC=0b11000000;//RX a TX nastavene ako vstupy RX=RC7, TX=RC6
    /*TRISCbits.TRISC6=1;
    TRISCbits.TRISC7=1;*/
      //RCSTAbits.SPEN=1;//povolenie USART
 RCSTA=(1<<_RCSTA_SPEN_POSITION)  //povolenie USART
       |(1<<_RCSTA_CREN_POSITION);//povolenie prijmu
 
 TXSTA=(1<<_TXSTA_TXEN_POSITION)   //povolenie vysielaca
       |(1<<_TXSTA_BRGH_POSITION); //vysoka rychlost
       //|(1<<_TXSTA_TX9_POSITION);//povolenie 9bit prenosu
      //TXSTA=0b00100100;
 SPBRG=25;//9615  Bd
}
/////////inicializacia jednotky usart////////////


 uint8_t UART_GetC()
{
  while (RCIF == 0) ;  
  if (OERR)  
  {  
    CREN = 0;
    CREN = 1;
  }  
  return RCREG;
}
 

//funkcia pre odoslanie retazca znakov
void USART_posli(char* text)
{
    uint8_t index=0;//index akutalneho znaku
    while(text[index]!='\0')//text zarazky
    {
        TXREG=text[index];//odosle jeden znak
        index++;//posun indexu
        while(TXSTAbits.TRMT==0);//caka na dokoncenie
    }
}
                     
                   
   
  
void UART_PutC(const char data)
{
  while (TRMT == 0);  
  TXREG = data;       
}
 
void uartPrint(const char *data)
{
  uint8_t i = 0;
  while (data[i] != '\0')
    UART_PutC (data[i++]);
}

void posliUartCislo(int i)
{
  char text[5];   
  sprintf(text," %d", i);
  uartPrint(text);  
}

char UART_Data_Ready()
{
  return RCIF;
}

char UART_Read()
{
  while(!RCIF);
  return RCREG;
}